;; Funkcje lispowe porwnujce cigi znakw zgodnie z polskimi
;; reguami sortowania

;; Author:  Kinga Izdebska
;; Created: September  2001      

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    

(provide 'polish-sort)


(defun char< (c1 c2)
(if (char-equal c1 c2)
nil
(progn
(let ((case-fold-search t)
      (pletters 
       (list  97 2353 98 99 2406 100 101 2410 102 103 104 105 
	    106 107 108 2355 109 110 2417 111 2419 112 
	    113 114 115 2358 116 117 118 119 120 121 122 
	    2364 2367))
      (found 0))
  (while (and (not (null pletters)) (eq found 0))
    (if (or (char-equal (car pletters) c1)
	    (char-equal (car pletters) c2))
	(setq found 1)
    (setq pletters (cdr pletters))))
  (if (not (null pletters))
      (char-equal (car pletters) c1)
    nil)))))

(defun polish-string< (s1 s2)
(if (or (null s1) (null s2))
(not (null s2))
(progn
(let ((case-fold-search t)
      (char1) (char2) (rest1 nil) (rest2 nil))
  (if (stringp s1)
      (progn 
	(setq char1 (string-to-char s1))
	(if (> (length s1) 0)
	    (setq rest1 (substring s1 1))))
					;s1 to char
    (setq char1 s1))
  (if (stringp s2)
      (progn
	(setq char2 (string-to-char s2))
	(if (> (length s2) 0)
	    (setq rest2 (substring s2 1))))
					;s2 to char
    (setq char2 s2))
  (if (char-equal   char1 char2)
  (polish-string< rest1 rest2)
  ;trzeba porwna znaki
  (char< char1 char2))))))


;(setq pletters  (list  97 2353 98 99 2406 100 101 2410 102 103 104 105 
;	    106 107 108 2355 109 110 2417 111 2419 112 
;	    113 114 115 2358 116 117 118 119 120 121 122 
;	    2364 2367))
;(setq c1 ')
;(setq c2 'a)
;(setq found 0)
;(while (and (not (null pletters)) (eq found 0))
;    (if (or (char-equal (car pletters) c1)
;	    (char-equal (car pletters) c2))
;	(setq found 1)
;    (setq pletters (cdr pletters))))
;found
;pletters

;(polish-string< "" "k")
;(setq s "s")
;(setq c (string-to-char s))
;(setq rest (substring s 1))







