#!/usr/bin/perl -w 

#   Copyright (C) 2001 Kinga Izdebska

#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.

#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

# commentary

# Napisany przez King Izdebsk, Lipiec 2001
# Udostpnia funkcje i  strukury danych, z ktrych korzystaj
# zmodyfikowana i dodane przeze mnie funcje do plikw
# reftex.el, reftex-index.el, bdce s czci Emacsa-21.0.99
# Wersja reftex 4.15
# Szczegy mona znale w treci mojej pracy magisterskiej

use File::Basename;

#nazwa pliku tynczasowego z zawartoci dla pliku frazowego reftex'a
$plik_sip="sambag.sip.tmp";
 
#lista opcjii uytych w programie
my @opcje = ( [qw(w wczytaj_wynik_sama)],
	      [qw(f podaj_formy_podstawowe)],
	      [qw(s czy_jest_slowo_w_slowniku)],
	      [qw(g podaj_kwalifikatory_gramatyczne)],
	      [qw(q zakoncz_program)],
	      [qw(pb zacznij_zaznaczanie)],
	      [qw(pe zakoncz_zaznaczanie)],
	      [qw(z czysc_zaznaczanie)],
	      [qw(b przetworz_plik_wynik_sam)],
	      [qw(n podaj_nastepne_slowo_z_pliku)]);

#umieci w pliku konfiguracyjnym

my $program="SAM";

my $sep="*";

#cig znakw, po ktrym nastpuje sowo w podanej do analizy formie
my $znacznik_formy ="interpret. formy:"; 

#cig znakw, po ktrym naspuje podane sowo w swojej formie podstawowej w kwalifikatorem gramatycznym
my $znacznik_hasla="haso:";

my $znacznik_gram_formy="forma:";

#cig znakw jaki pojawia si w gwnym trybie SAMA
my $sam_znak=$program . ">";

#cig znakw jaki pojawia si w  trybie do analizy SAMA
my $sam_znak_anal=$program . " analiza>";


my $sam_begin="<";
my $sam_end= ">";

my %slownik = (); #na pocztku sonik jest pusty

my %slowa_z_pliku= ();
my @klucze=();
my $true=1;
my $false=0;
#czy zaznaczamy kolejne formy podstawowe, ktre podajemy
my $zaznaczanie = $false;


# struktura zawartoci sownika
# kluczem jest podane analizatorowi sowo
# wartoci spod klucza {sowo} jest lista interpretacji dla
# danego {sowa} podanych przez SAM'a
# pojedynczy element listy jest rwnie list skadajc si z trzech elementw:
# 1 element - forma podstawowa podanego sowa
# 2 element - kwalifikator gramatyczny dla formy podstawowej sowa (1 element)
# 3 element - kwalifikatow gramatyczny podanego sowa

sub main;               #gwna procedura programu 
sub wczytaj_wynik_sama; #wczytuje wynik dla jakiego sowa podany przez program SAM

sub podaj_formy_podstawowe;          #podaje list form podstawowych dla podanego sowa

sub podaj_kwalifikatory_gramatyczne; #podaje kwalifikatory gramatyczne dla podanego na wejciu hasa i formy
                                     #jeli zostay wczytane wczeniej do sownika
sub czy_jest_slowo_w_slowniku;        #sprawdza czy podany na wejciu sowa zostao zapisane w sowniku 

sub przelacz_zaznaczanie;            #wcza/wyacza zaznaczanie ostatnio podanej formy podstawowej ze sownika

sub czysc_zaznaczanie;               # ustawia zaznaczaony element na pierwszy na licie
sub zakoncz_program;                 #zakonczenie dziaania programu

sub przetworz_plik_wynik_sam;        #przetwarza plik wyniki.sam (nazwa pliku zostaje podana na wej/sciu)

sub podaj_nastepne_slowo_z_pliku;    #do wypeniania bufora samowego sip
                                     #neiwykorzytsane, gdy wstawianie kolejnych sw do bufora
                                     #w elisp jest bardzxo wolne

sub trim;


#wykonanie programu
main();

sub trim {
    my @out = @_;
    for (@out) {
	s/^\s+//;
	s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}


sub main {
  PROGRAM: while ($dane=<>) {
      chomp($dane);
      foreach $wartosc ( @opcje ){
	  ($opcja, $funkcja)=@$wartosc;
	  if ($dane eq $opcja) {
	      eval $funkcja . "();";
	      next PROGRAM;
	  }
      }
  }
}


sub wczytaj_wynik_sama {
#tryb analizy wynikw sama
    #print "Tryb analizy wynikw nalizatora morfologicznego SAM\n";
    #print "Musi zosta podany w pomidzy $sam_begin i $sam_end:\n";
    my $sam_wynik =<>; #pierwsza linia, powinna zaczyna si od < 
    my $nawias1 = ($sam_wynik =~ /$sam_begin/ );
    my $nawias2 = ($sam_wynik =~ /$sam_end/);

    ! $nawias1  and return(()); #nie podano otwierajcego nawiasu
                                 #ignorujemy reszt
    if (! $nawias2 ) {          #nie wczytano nawiasu kocowego
	while (<>){
	    $sam_wynik .= $_;
	    if ( /$sam_end$/ ) { 
		$nawias2 = 1;
		last; 
	    } 
	}
    }

    
    (! nawias1 or ! nawias2 or $sam_wynik eq "") and return("");

    #dopasowanie globalne bez rozrninia maych i duych liter'

    #usuwamy propmpty, jeli si zapltay $sam_znak i $sam_znak_anal
    $sam_wynik =~ s/($sam_znak)//g;
    $sam_wynik =~ s/($sam_znak_anal)//g;

    # znak "litera zamieniamy na polkie litery
    @literki=( ["\"A",""],["\"a",""],
	   ["\"C",""],["\"c",""],
	   ["\"E",""],["\"e",""],
	   ["\"L",""],["\"l",""],
	   ["\"N",""],["\"n",""],
	   ["\"O",""],["\"o",""],
	   ["\"S",""],["\"s",""],
	   ["\"R",""],["\"r",""],
	   ["\"Z",""],["\"z",""]);

    for $i (0..$#literki){
	$sam_wynik =~ s/($literki[$i][0])/$literki[$i][1]/g;
    }



    #forma podana do analizy
    (my $sam_forma) = ($sam_wynik =~ /$znacznik_formy\s+([\wʳӶ]+)/gi );
		     
    #zwrcone formy podstawowe
    (my @sam_hasla) = ($sam_wynik =~ /$znacznik_hasla\s+([\wʳӶ]+).*/gi ); 

    (my @sam_hasla_formy_gr)=  ($sam_wynik =~ /$znacznik_hasla\s+[\wʳӶ]+ \s*\(\s*(.*)\s*\).+/gi );

    (my @sam_forma_gr) = ($sam_wynik =~ /$znacznik_gram_formy\s+.*\( (.*) \)/gi );

     my @hasla_i_formy_gr=();

    while (@sam_hasla and @sam_hasla_formy_gr and @sam_forma_gr){
	$haslo=pop(@sam_hasla);
	$gram=pop(@sam_hasla_formy_gr);
	$forma_gram=pop(@sam_forma_gr);

	@lista=($haslo,$gram, $forma_gram, $false);
	push(@hasla_i_formy_gr,[ @lista ]);
    }



    if ( $sam_forma){
	#wstawienie do sownika
	#wartoci klucza jest tablica z formami podstawowymi
	$slownik{$sam_forma}=[ @hasla_i_formy_gr ]; 
    }

}

sub podaj_formy_podstawowe {
    my $slowo=<>;
    chomp($slowo);
    $slowo=trim($slowo);
    #na wejcie wypisujemy formy podstawowe dla podanego sowa oddzielone spacjami
    #print "\n";
    if ($slowo and exists $slownik{$slowo}) {
	@formy_podstawowe=@{$slownik{$slowo}};
	 for $i (0 .. $#formy_podstawowe) {
	     if ($i eq $#formy_podstawowe) {
		 print "$formy_podstawowe[$i]->[0]" ;
	     }
	     else {
		 print "$formy_podstawowe[$i]->[0] ";
	     }
	 }
     }
    else {
	print "";
    }
    print "\n";
}

#do modyfikacji dla powtarzajcych  si sw 
#znacznik, ktre ostatno wczytane
sub podaj_kwalifikatory_gramatyczne
{
    my $haslo=<>;
    my $forma=<>;
    chomp($forma);
    chomp($haslo);
    $forma=trim($forma);
    $haslo=trim($haslo);
    if (exists ($slownik{$haslo})) {
	@lista=@{$slownik{$haslo}};
        #@lista jest list cztero-elementowych tablic
	foreach $elem (@lista) {
	    if ( ($forma eq $elem->[0]) and (not $zaznaczanie or ($elem->[3] eq $false)))
	    {
		print $forma . $sep . trim($elem->[1]) . $sep . $haslo. $sep . trim($elem->[2]) . $sep;
		$elem->[3]=$true;
		last;
	    }
	}
    }
    print "\n";    
}

# 0 - jest
# 1 - nie ma
# jeli nie podano sowa jako paramentru funkcji to pobiera go z wejcia
sub czy_jest_slowo_w_slowniku {
    $slowo="";
    if (@_ >0) {
	$slowo=@_->[0];
    }
    else {
	$slowo=<>;
	chomp($slowo);
	$slowo=trim($slowo);
    }
    if (exists $slownik{$slowo}){
	print "0\n";
    }
    else {
	print "1\n";
    }
}

sub zacznij_zaznaczanie {

    $zaznaczanie=$true;
}

sub zakoncz_zaznaczanie {

    $zaznaczanie=$false;

}

sub czysc_zaznaczanie {
    $slowo="";
    if (@_ >0) {
	$slowo=@_->[0];
    }
    else {
	$slowo=<>;
	chomp($slowo);
	$slowo=trim($slowo);
    }
    if (exists ($slownik{$slowo})) {
	@lista=@{$slownik{$slowo}};
        #@lista jest list cztero-elementowych tablic
	# czwarty element tablicy to znacznik
	foreach $elem (@lista) {
	    $elem->[3]=$false
	    }
    }
}

sub przetworz_plik_wynik_sam {

    $plik_sama="";
    if (@_ >0) {
	$plik_sama=@_->[0];
    }
    else {
	$plik_sama=<>;
	chomp($plik_sama);
	$plik_sama=trim($plik_sama);
    }


    #wczytanie zawartoci pliku
    %slowa_z_pliku=();
    open(WYNIK,"< $plik_sama") or do {
	print "!\n";
	return;
    };

    @plik=<WYNIK>;
    close(WYNIK);

    #plik tymczaoswy postaci takiej jak dla dla pliku frazowego emacsa

    $plik_sip= dirname($plik_sama). "/" .$plik_sip ;
    open(TMP,"> $plik_sip");

    # zakadamy konkretny format danyc z sama tzn.
    # 1 linia - analizowane sowo. Na kocu musi wystpi znak %
    #           moe by przeniesiony do nastpnej linii tzn:
    # wyniki.sam <1> : slowo %
    # albo 
    # wyniki.sam <1>: slowo
    # wyniki.sam <2>: %
    # nastpne linie to wyniki analizy dla danego soa ograniczone przez { ... }
    # pojedyncza interpretacja jest zawarta rwnie w { ... }
    # kada linia zakoczona jest %
    # gramatyka dla tego pliku moe zosta zdefiniowana nastpujco
    # (program nie rozpozna formatu pliku nie bdcego zgodn z podan gramatyk!!!)
    # plik_wyniki_sama    -> EMPTY | analizy_slow
    # analizy_slow        -> analiza_slowa | analiza_slowa analizy_slow
    # analiza_slowa       ->  analizowane_slowo "\n" % "\n" reszta_analizy |
    #                        analizowane_slowo % "\n" reszta_analizy
    # reszta_analizy      -> { pojedyncze_analizy } % "\n"
    # pojedyncze_analizy  -> EMPTY | pojedyncze_analizy ostatnia_pojedyncza_analiza | ostatnia-pojedyncza_analiza
    # pojedyncze_amalizy -> pojedyncza_analiza | pojedyncza_analiza pojedyncze_analizy 
    # pojedyncza_analiza -> "{" "(" kwal_gram_analizowanego_slowa ")" "<" forma_podstawowa 
    #                          "(" kwal_gram_formy_podtsawowej ")" "}" "%" "\n"
    # ostatnia_pojedyncza_analiza -> "{" "(" kwal_gram_analizowanego_slowa ")" "<" forma_podstawowa 
    #                               "(" kwal_gram_formy_podtsawowej ")" "}" 

    # poziomy wczytywania 
    # 0 - pocztek szukamy analizowanego sowa
    # 1 - pocztkowy %
    # 2 -wczytanie pierwszej analizy sowa
    # 3 - zakoczenie wczytywania analizy dla danego sowa i zapisanie tego w lowniku

    $poziom=0;
    my $analizowane_slowo="";
    my @lista_dla_analizowanego_slowa=();
    my $kwal_gram_analizowanego_slowa="";
    my $forma_podstawowa_analizowanego_slowa="";
    my $kwal_gram_formy_podstawowej="";
    my $jest_procent=0;
    my $pierwsza_analiza = 1;

    $wskaznik=0;
    while ($wskaznik<=$#plik) {
	$linia=$plik[$wskaznik];
	$wskaznik++;
	$poziom eq 0 and do  {
	    $analizowane_slowo="";
	    $reszta="";
	    $jest_procent=0;
	    if (!(($analizowane_slowo,$reszta)= ($linia =~ /^\s*([\wʳӶ]+)\s*(%{0,1})\s*$/ ))){
		$poziom=0;
		next;
	    }
	    if (length($reszta)==1){
		$jest_procent=1;
	    }
	    if ($analizowane_slowo) {

		$jest_procent==1 and $poziom=2;
		$jest_procent==0 and $poziom=1;
	    }
	    $jest_procent=0;
	    $pierwsza_analiza=1;
	    @lista_dla_analizowanego_slowa=();
	    next;};
  	$poziom eq 1 and do  {
	    #potrzebny jeszcze jest %, eby zakozy wczytywanie analizowanego sowa
	    if ($linia =~ /^\s*%\s*$/){
		$poziom = 2;
	    }
	    else {
		$poziom= 0;
	    }
	    next;};
	$poziom eq 2 and do  {
	    #pierwsza analiza wczytanego wczeniej sowa

	    if ($pierwsza_analiza == 1) {
		if (!(($linia) = ($linia =~ /\s*\{(.*)/ ))){
		    if ($analizowane_slowo) {
			$poziom=3;
		    }
		    else {
			$poziom=0;
		    }
		    $pierwsza_analiza=0;
		    next;
		}
		else{
		    $pierwsza_analiza=0;
		}
	    }
	    $nawiasy="";
	    $kwal_gram_analizowanego_slowa="";
	    $forma_podstawowa_analizowanego_slowa="";
	    $kwal_gram_formy_podstawowej="";
	    if (!(($kwal_gram_analizowanego_slowa,$forma_podstawowa_analizowanego_slowa,$kwal_gram_formy_podstawowej,$nawiasy) 
		  = ($linia =~ /^\s*\{\s*\((.*)\)\s*< \s*([\wʳӶ]+)\s*\((.*)\)\+{0,1}\s*\}\s*(\}{0,1})\s*%\s*$/ ))) {
		 if ($analizowane_slowo) {
		     $poziom=3;
		 }
		 else {
		     $poziom=0;
		 }
		next;
	    }

	    @lista=($forma_podstawowa_analizowanego_slowa, $kwal_gram_formy_podstawowej,$kwal_gram_analizowanego_slowa,$false);
	    push( @lista_dla_analizowanego_slowa, [ @lista ]);
	    #liczymy nawiasy, eby sprawdzi czy to ju koniec interpretacji
	     if (length($nawiasy)==1) {
		$poziom=3;
	    }
	    elsif (length($nawiasy)==0) {
		$poziom=2;
	    }
	    else {
		$poziom=0;
	    }
	    if ($poziom==0 and $analizowane_slowo) {
		$poziom=3;
	    }
	    if ($poziom != 3) {
		next;
	    }

	};
	$poziom eq 3 and do {
	    if (not (exists $slowa_z_pliku{$analizowane_slowo})) {

		if ($analizowane_slowo ) {
		    $slownik{$analizowane_slowo}=[ @lista_dla_analizowanego_slowa ];
		}
		print TMP "\t$analizowane_slowo";
		
		if ($#lista_dla_analizowanego_slowa == -1) {
		    print TMP "\n";
		}
		else {
		    print TMP "\t";
		    for $i (0 .. $#lista_dla_analizowanego_slowa-1) {
			print TMP $lista_dla_analizowanego_slowa[$i]->[0] . "|| ";
		    }
		    print TMP $lista_dla_analizowanego_slowa[$#lista_dla_analizowanego_slowa]->[0] . "\n";
		}
		$slowa_z_pliku{$analizowane_slowo}="T";
	    }
	    $poziom=0;
	    next;};
	  
    }	
    close(TMP);
    @klucze=sort keys %slowa_z_pliku;
    print "k\n";
}

sub podaj_nastepne_slowo_z_pliku {
    if ($#klucze == -1) {
	print "\n";
    }
    else {
	$ind=shift(@klucze);
	if (exists $slowa_z_pliku{$ind}) {
	    print $ind . "\n";
	    delete $slowa_z_pliku{ind};
	}
   }
}
 
sub zakoncz_program {
    exit 0;
}


